/*
 *	BIRD -- Layer3 VPN Protocol Configuration
 *
 *	(c) 2011 Yandex, LLC
 *      Author: Alexander V. Chernikov <melifaro@yandex-team.ru>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#ifndef _BIRD_L3VPN_H_
#define _BIRD_L3VPN_H_

#define VPN_TO_PE	1
#define PE_TO_VPN	2

struct l3vpn_config {
  struct proto_config c;
  struct rtable_config *vpn_table;	/* Table we're connected to */
  struct rtable_config *mpls_table;	/* Table to insert LDP labels to */
  u64 rd;				/* VPN route distinguisher */
};

struct l3vpn_proto {
  struct proto p;
  struct rtable *vpn_table;
  struct rtable *mpls_table;		/* Table to insert LDP labels to */
  u64 rd;				/* VPN route distinguisher */
  u32 label;				/* MPLS label */
  struct timer *request_timer;		/* Timer for retrying label requests */
  struct proto_stats vpn_stats;		/* Statistics for the direction vpn -> local */
  struct announce_hook *a;		/* Announce hook for vpn table */
};

extern struct protocol proto_l3vpn;

#endif
